﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace gestione_semaforo
{
    public partial class Form1 : Form
    {
        /****************GLOBAL VARIABLES****************/
        int timer = 10;
        int cnt = 0;
        int limit;
        Boolean STOP = false;
        String current_path="";
        String[] tmp_path = new String[20];

        /**********************************************************************************
         * Name:                 Form1()                                                  *
         * Target:               Constructor of the class.                                *
         * Input parameters:     Nothing.                                                 *
         * Output parameters:    Nothing.                                                 *
         *********************************************************************************/
        public Form1()
        {
            current_path = System.Windows.Forms.Application.ExecutablePath;
            tmp_path = current_path.Split('\\');

            current_path = "";
            for (int i = 0; i < tmp_path.Count() - 1; i++)
                current_path = current_path + tmp_path[i] + "\\";

            InitializeComponent();
        }

        /**********************************************************************************
         * Name:               button_exit_Click()                                        *
         * Target:             Close the application.                                     *
         * Input parameters:   Nothing.                                                   *
         * Output parameters:  Nothing.                                                   *
         *********************************************************************************/ 
        private void button_exit_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        /**********************************************************************************
        * Name:               button_exit_Click()                                        *
        * Target:             Close the application.                                     *
        * Input parameters:   Nothing.                                                   *
        * Output parameters:  Nothing.                                                   *
        *********************************************************************************/ 
        private void button_start_Click(object sender, EventArgs e)
        {            
            Boolean red=false;
            STOP = false;
            pictureBox_s1.Image = Image.FromFile(current_path+"green_light.png");
            this.Refresh();
            while (true)
            {
                System.Threading.Thread.Sleep(1000);
                cnt++;
                if (cnt > limit)
                {
                    if (red == false)
                    {
                        pictureBox_s2.Image = Image.FromFile(current_path + "yellow_light.png");
                        pictureBox_s1.Image = null;
                        this.Refresh();
                        System.Threading.Thread.Sleep(3000);
                        cnt = 0;
                        pictureBox_s2.Image = null;
                        pictureBox_s3.Image = Image.FromFile(current_path + "red_light.png");
                        this.Refresh();
                        red = true;
                    }
                    else
                    {
                        pictureBox_s1.Image = Image.FromFile(current_path + "green_light.png");
                        pictureBox_s3.Image = null;
                        this.Refresh();
                        cnt = 0;
                        red = false;
                    }
                }
                System.Windows.Forms.Application.DoEvents();
                if (STOP == true)
                    break;
            }
        }

        /**********************************************************************************
        * Name:               button_exit_Click()                                        *
        * Target:             Close the application.                                     *
        * Input parameters:   Nothing.                                                   *
        * Output parameters:  Nothing.                                                   *
        *********************************************************************************/ 
        private void button_timer_Click(object sender, EventArgs e)
        {
            if (textBox1.Text == "")
                MessageBox.Show("Attenzione: inserire valore corretto del timer.");
            else
                limit = Convert.ToInt32(textBox1.Text) / 2;
        }

        /*********************************************************************************
        * Name:               button_call_Click()                                        *
        * Target:             Call the semaphore.                                        *
        * Input parameters:   Nothing.                                                   *
        * Output parameters:  Nothing.                                                   *
        *********************************************************************************/
        private void button_call_Click(object sender, EventArgs e)
        {
            limit = (Convert.ToInt32(textBox1.Text)/2) / 1000;
        }

        /*********************************************************************************
        * Name:               button_stop_Click()                                        *
        * Target:             Stop the running status.                                   *
        * Input parameters:   Nothing.                                                   *
        * Output parameters:  Nothing.                                                   *
        *********************************************************************************/ 
        private void button_stop_Click(object sender, EventArgs e)
        {
            STOP = true;
        }

        /*********************************************************************************
        * Name:               Form1_Load()                                               *
        * Target:             Load all controls of program.                              *
        * Input parameters:   Nothing.                                                   *
        * Output parameters:  Nothing.                                                   *
        *********************************************************************************/ 
        private void Form1_Load(object sender, EventArgs e)
        {
            textBox1.Text = timer.ToString();
            limit = timer;
        }
    }
}
